#include <iostream>
#include <fstream>
#include <cmath>
#include <hash_map.h>
#include <list>

using namespace std;

hash_map< int, list<int> > dbuser;
hash_map< int, list<int> > dbitem;
hash_map< int, hash_map<int, float> > sims;


inline void rate(int user, int item, float rating){
	//Almacenamos el rating
	dbuser[user].push_front(rating);
	dbitem[item].push_front(rating);

	//Comparamos todos los ratings de este ítem
	list<int>::iterator it = dbitem[item].begin();
	list<int>::iterator end = dbitem[item].end();

	hash_map<int, float> & user_sim = sims[user];

	while(it != end){
		user_sim[*it] = 1;
		++it;
	}
}

int main(int argc, char * argv[]){
	FILE *f = fopen(argv[1], "r");
	
	int user,item,tstamp;
	float value;
	int ratings = 0;
	
//	while (fscanf(f, "%d %d %d %d",&user,&item,&value,&tstamp) != EOF) {
	while (fscanf(f, "%d::%d::%f::%d",&user,&item,&value,&tstamp) != EOF) {
//		printf("%d :: %d -> %f\n", user, item, value);
		rate(user, item, value);
		if((ratings++ % 10000) == 0) {printf("%d ", ratings); fflush(stdout);}
	}
}
