/*
    Copyright 2010 Luis Miguel Merino Bonilla

    This file is part of GNU Taste

    GNU Taste is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    GNU Taste is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with GNU Taste. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __LOG__
#define __LOG__

#include <cstring>
#include <iostream>
#include <iomanip>
#include <ctime>


void log(string s){
	cout << "[" << setw(6)<< setiosflags(ios::fixed) << setprecision(2)<< 1.0*clock()/CLOCKS_PER_SEC << "] " << s << endl;
}

#endif
